{ config, ... }:

{
  system.stateVersion = "22.05";

  c3d2.hq.statistics.enable = true;
  c3d2.deployment = {
    server = "server10";
    mounts = [ "etc" "var"];
  };
  microvm = {
    vcpu = 16;
    mem = 6 * 1024;
  };

  networking = {
    hostName = "caveman";
    firewall.allowedTCPPorts = [ 80 443 ];
  };

  services.caveman = {
    redis.maxmemory = config.microvm.mem * 1024 * 1024 * 3 / 2;

    hunter = {
      enable = true;
      settings = {
        max_workers = config.microvm.vcpu * 2;
        hosts = with builtins;
          filter isString (
            split "\n" (
              readFile ./mastodon-instances.txt
            )
          );
      };
    };
  };

  # services = {
  #   nginx = rec {
  #     enable = true;
  #     virtualHosts."" = {
  #       default = true;
  #       forceSSL = true;
  #       enableACME = true;
  #     };
  #   };
  # };
}
